---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for WR aux sma output generation module
---------------------------------------------------------------------------------------
-- File           : sma_config_wb_slave.vhd
-- Author         : auto-generated by wbgen2 from sma_config.wb
-- Created        : Mon Oct 17 22:55:06 2022
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE sma_config.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.sma_config_wbgen2_pkg.all;


entity sma_config_wb is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(3 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
    regs_i                                   : in     t_sma_config_in_registers;
    regs_o                                   : out    t_sma_config_out_registers
  );
end sma_config_wb;

architecture syn of sma_config_wb is

signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(3 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      regs_o.sma0_mux_load_o <= '0';
      regs_o.sma1_mux_load_o <= '0';
      regs_o.cus_prh_load_o <= '0';
      regs_o.cus_prl_load_o <= '0';
      regs_o.cus_csr_load_o <= '0';
      regs_o.pps_prh_load_o <= '0';
      regs_o.pps_csr_load_o <= '0';
      regs_o.utc_csr_load_o <= '0';
      regs_o.sma0_fdly_load_o <= '0';
      regs_o.sma1_fdly_load_o <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          regs_o.sma0_mux_load_o <= '0';
          regs_o.sma1_mux_load_o <= '0';
          regs_o.cus_prh_load_o <= '0';
          regs_o.cus_prl_load_o <= '0';
          regs_o.cus_csr_load_o <= '0';
          regs_o.pps_prh_load_o <= '0';
          regs_o.pps_csr_load_o <= '0';
          regs_o.utc_csr_load_o <= '0';
          regs_o.sma0_fdly_load_o <= '0';
          regs_o.sma1_fdly_load_o <= '0';
          ack_in_progress <= '0';
        else
          regs_o.sma0_mux_load_o <= '0';
          regs_o.sma1_mux_load_o <= '0';
          regs_o.cus_prh_load_o <= '0';
          regs_o.cus_prl_load_o <= '0';
          regs_o.cus_csr_load_o <= '0';
          regs_o.pps_prh_load_o <= '0';
          regs_o.pps_csr_load_o <= '0';
          regs_o.utc_csr_load_o <= '0';
          regs_o.sma0_fdly_load_o <= '0';
          regs_o.sma1_fdly_load_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(3 downto 0) is
          when "0000" => 
            if (wb_we_i = '1') then
              regs_o.sma0_mux_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= regs_i.sma0_mux_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0001" => 
            if (wb_we_i = '1') then
              regs_o.sma1_mux_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= regs_i.sma1_mux_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0010" => 
            if (wb_we_i = '1') then
              regs_o.cus_prh_load_o <= '1';
            end if;
            rddata_reg(28 downto 0) <= regs_i.cus_prh_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0011" => 
            if (wb_we_i = '1') then
              regs_o.cus_prl_load_o <= '1';
            end if;
            rddata_reg(28 downto 0) <= regs_i.cus_prl_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0100" => 
            if (wb_we_i = '1') then
              regs_o.cus_csr_load_o <= '1';
            end if;
            rddata_reg(28 downto 0) <= regs_i.cus_csr_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0101" => 
            if (wb_we_i = '1') then
              regs_o.pps_prh_load_o <= '1';
            end if;
            rddata_reg(28 downto 0) <= regs_i.pps_prh_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0110" => 
            if (wb_we_i = '1') then
              regs_o.pps_csr_load_o <= '1';
            end if;
            rddata_reg(28 downto 0) <= regs_i.pps_csr_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0111" => 
            if (wb_we_i = '1') then
              regs_o.utc_csr_load_o <= '1';
            end if;
            rddata_reg(28 downto 0) <= regs_i.utc_csr_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1000" => 
            if (wb_we_i = '1') then
              regs_o.sma0_fdly_load_o <= '1';
            end if;
            rddata_reg(8 downto 0) <= regs_i.sma0_fdly_i;
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1001" => 
            if (wb_we_i = '1') then
              regs_o.sma1_fdly_load_o <= '1';
            end if;
            rddata_reg(8 downto 0) <= regs_i.sma1_fdly_i;
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- SMA0 Signal Selection
  regs_o.sma0_mux_o <= wrdata_reg(7 downto 0);
-- SMA1 Signal Selection
  regs_o.sma1_mux_o <= wrdata_reg(7 downto 0);
-- High state length
  regs_o.cus_prh_o <= wrdata_reg(28 downto 0);
-- Low state width
  regs_o.cus_prl_o <= wrdata_reg(28 downto 0);
-- Coarse shift value in 2ns cycles.
  regs_o.cus_csr_o <= wrdata_reg(28 downto 0);
-- High state width
  regs_o.pps_prh_o <= wrdata_reg(28 downto 0);
-- Coarse shift value
  regs_o.pps_csr_o <= wrdata_reg(28 downto 0);
-- Coarse shift value
  regs_o.utc_csr_o <= wrdata_reg(28 downto 0);
-- fine delay counter
  regs_o.sma0_fdly_o <= wrdata_reg(8 downto 0);
-- fine delay counter
  regs_o.sma1_fdly_o <= wrdata_reg(8 downto 0);
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
